package cn.iocoder.yudao.module.supplier.service.product;

import cn.iocoder.yudao.module.supplier.controller.admin.product.vo.ContactPageReqVO;
import cn.iocoder.yudao.module.supplier.controller.admin.product.vo.ContactSaveReqVO;
import cn.iocoder.yudao.module.supplier.dal.dataobject.product.ContactDO;
import cn.iocoder.yudao.module.supplier.dal.mysql.product.ContactMapper;
import cn.iocoder.yudao.module.supplier.enums.ErrorCodeConstant;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;


import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 供应商联系人 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class ContactServiceImpl implements ContactService {

    @Resource
    private ContactMapper supplierContactMapper;

    @Override
    public Long createContact(ContactSaveReqVO createReqVO) {
        // 插入
        ContactDO contact = BeanUtils.toBean(createReqVO, ContactDO.class);
        supplierContactMapper.insert(contact);
        // 返回
        return contact.getId();
    }

    @Override
    public void updateContact(ContactSaveReqVO updateReqVO) {
        // 校验存在
        validateContactExists(updateReqVO.getId());
        // 更新
        ContactDO updateObj = BeanUtils.toBean(updateReqVO, ContactDO.class);
        supplierContactMapper.updateById(updateObj);
    }

    @Override
    public void deleteContact(Long id) {
        // 校验存在
        validateContactExists(id);
        // 删除
        supplierContactMapper.deleteById(id);
    }

    private void validateContactExists(Long id) {
        if (supplierContactMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstant.NOT_EXISTS);
        }
    }

    @Override
    public ContactDO getContact(Long id) {
        return supplierContactMapper.selectById(id);
    }

    @Override
    public PageResult<ContactDO> getContactPage(ContactPageReqVO pageReqVO) {
        return supplierContactMapper.selectPage(pageReqVO);
    }

}
